#ifndef COMPOSITELIB_H
#define COMPOSITELIB_H

#include "Composite_global.h"
#include "Smp/ISimulator.h"
#include "Smp/IPublication.h"

extern "C"
{
	/**
	 * Initialise function for dynamic package.
	 * @param simulator simulation environment reference
	 * @param typeRegistry type register reference
	 */
     COMPOSITESHARED_EXPORT bool Initialise(Smp::ISimulator* simulator,
			Smp::Publication::ITypeRegistry* typeRegistry);

	/**
	 * Finalise function for dynamic package.
	 */
    COMPOSITESHARED_EXPORT bool Finalise();
}

#endif // COMPOSITELIB_H

