#include "Model2_Level2.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type Model2_Level2
// UUID: 72A03B2B-AFE2-492b-80F2-924C81537E72
const SB::Uuid Catalogue::Uuid_Model2_Level2("72A03B2B-AFE2-492b-80F2-924C81537E72");

Catalogue::Model2_Level2::Model2_Level2()
{
	_Init();
}

Catalogue::Model2_Level2::Model2_Level2(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Catalogue::Model2_Level2::~Model2_Level2()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Catalogue::Model2_Level2::_Init()
{

	//////// Entry Points

	//////// References

	//////// Containers

	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Catalogue::Model2_Level2::_Destroy()
{
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Catalogue::Model2_Level2::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Catalogue::Model2_Level2::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Catalogue::Model2_Level2::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Fields

}

