#include "Model1_Level1.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type Model1_Level1
// UUID: 9DA9886F-56C3-4511-8251-53DB7B2ACE54
const SB::Uuid Catalogue::Uuid_Model1_Level1("9DA9886F-56C3-4511-8251-53DB7B2ACE54");

Catalogue::Model1_Level1::Model1_Level1()
{
	_Init();
}

Catalogue::Model1_Level1::Model1_Level1(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Catalogue::Model1_Level1::~Model1_Level1()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Catalogue::Model1_Level1::_Init()
{

	//////// Entry Points

	//////// References

	//////// Containers
	_ContainerD = SB::Management::ManagedContainer< Model1_Level2 >::CreateInstance(
		"ContainerD" 
		, ""
		, this
	);
		ContainerD = _ContainerD;


	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Catalogue::Model1_Level1::_Destroy()
{
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Catalogue::Model1_Level1::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Catalogue::Model1_Level1::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Catalogue::Model1_Level1::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{
	// Temp reference to publish operation's parameters
	Smp::Publication::IPublishOperation* operation = NULL;

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Fields

}

