#include "Model3_Level1.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type Model3_Level1
// UUID: 6A4A8248-CD3F-4979-A427-9A2A9CF7B4DE
const SB::Uuid Catalogue::Uuid_Model3_Level1("6A4A8248-CD3F-4979-A427-9A2A9CF7B4DE");

Catalogue::Model3_Level1::Model3_Level1()
{
	_Init();
}

Catalogue::Model3_Level1::Model3_Level1(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Catalogue::Model3_Level1::~Model3_Level1()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Catalogue::Model3_Level1::_Init()
{

	//////// Entry Points

	//////// References

	//////// Containers
	_ContainerE = SB::Management::ManagedContainer< Model2_Level2 >::CreateInstance(
		"ContainerE" 
		, ""
		, this
	);
		ContainerE = _ContainerE;


	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Catalogue::Model3_Level1::_Destroy()
{
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Catalogue::Model3_Level1::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Catalogue::Model3_Level1::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Catalogue::Model3_Level1::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{
	// Temp reference to publish operation's parameters
	Smp::Publication::IPublishOperation* operation = NULL;

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Fields

}

