#include "ModelInterfaces.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type ModelInterfaces
// UUID: 1567EAE2-7F4D-4dd6-9634-1CD30BB39536
const SB::Uuid Catalogue::Uuid_ModelInterfaces("1567EAE2-7F4D-4dd6-9634-1CD30BB39536");

Catalogue::ModelInterfaces::ModelInterfaces()
{
	_Init();
}

Catalogue::ModelInterfaces::ModelInterfaces(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Catalogue::ModelInterfaces::~ModelInterfaces()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Catalogue::ModelInterfaces::_Init()
{

	//////// Entry Points

	//////// References

	//////// Containers

	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Catalogue::ModelInterfaces::_Destroy()
{
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Catalogue::ModelInterfaces::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Catalogue::ModelInterfaces::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Catalogue::ModelInterfaces::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{
	// Temp reference to publish operation's parameters
	Smp::Publication::IPublishOperation* operation = NULL;

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Fields

}

void Catalogue::ModelInterfaces::serviceInterface1()
{
	// User code here
}

Smp::Int16 Catalogue::ModelInterfaces::serviceInterface2(Smp::Bool param1)
{
	// User code here
	return Smp::Int16()
}

